package net.knarcraft.bookswithoutborders.command;

import net.knarcraft.bookswithoutborders.BooksWithoutBorders;
import net.knarcraft.bookswithoutborders.state.ItemSlot;
import net.knarcraft.bookswithoutborders.utility.InventoryHelper;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;

/**
 * Command executor for the save public command
 */
public class CommandSavePublic implements CommandExecutor {

    private final BooksWithoutBorders booksWithoutBorders;

    public CommandSavePublic(BooksWithoutBorders booksWithoutBorders) {
        this.booksWithoutBorders = booksWithoutBorders;
    }

    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {
        if (!(sender instanceof Player player)) {
            BooksWithoutBorders.sendErrorMessage(sender, "This command can only be used by a player!");
            return false;
        }

        ItemSlot holdingSlot = InventoryHelper.getHeldSlotBook(player, false, false, false, false);
        if (holdingSlot != ItemSlot.NONE) {
            ItemStack holdingItem = InventoryHelper.getHeldItem(player, holdingSlot == ItemSlot.MAIN_HAND);
            if (args.length == 1) {
                booksWithoutBorders.saveBook(player, holdingItem, args[0], true);
            } else {
                booksWithoutBorders.saveBook(player, holdingItem, "false", true);
            }
            return true;
        } else {
            BooksWithoutBorders.sendErrorMessage(sender, "You must be holding a written book or book and quill to save it!");
            return false;
        }
    }

}
